diff --git a/drupal7/sites/all/modules/file_entity/file_entity.field.inc b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
index 97f3c280..2a3700c1 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.field.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.field.inc
@@ -160,6 +160,11 @@ function file_entity_field_formatter_settings_form($field, $instance, $view_mode
       '#type' => 'checkbox',
       '#default_value' => $settings['loop'],
     );
+    $element['muted'] = array(
+      '#title' => t('Muted'),
+      '#type' => 'checkbox',
+      '#default_value' => $settings['muted'],
+    );
     $element['width'] = array(
       '#type' => 'textfield',
       '#title' => t('Width'),
@@ -220,10 +225,8 @@ function file_entity_field_formatter_settings_summary($field, $instance, $view_m
     if (isset($settings['multiple_file_behavior'])) {
       $summary[] = t('Multiple files: %multiple', array('%multiple' => $settings['multiple_file_behavior']));
     }
-
   }
   elseif ($display['type'] === 'file_video') {
-    $summary_items = array();
     if (isset($settings['controls'])) {
       $summary[] = t('Controls: %controls', array('%controls' => $settings['controls'] ? 'visible' : 'hidden'));
     }
@@ -286,6 +289,9 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
     foreach ($items as $delta => $item) {
       if (!isset($recursion_queue[$item['fid']])) {
         $files_display[$item['fid']] = file_load($item['fid']);
+        if (!empty($item['description'])) {
+          $files_display[$item['fid']]->description = $item['description'];
+        }
       }
     }
 
@@ -293,6 +299,7 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
     if ($files_display) {
       foreach ($files_display as $fid => $file) {
         $files_display[$fid]->referencing_entity = $entity;
+        $files_display[$fid]->referencing_entity_type = $entity_type;
         $files_display[$fid]->referencing_field = $field['field_name'];
       }
       $output = file_view_multiple($files_display, $view_mode);
@@ -330,14 +337,14 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
     if ($multiple_file_behavior == 'tags') {
       foreach ($items as $delta => $item) {
         if ($item['type'] == 'audio') {
-          $source_lists[] = array($item);
+          $source_lists[$delta] = array($item);
         }
       }
     }
     else {
       foreach ($items as $delta => $item) {
         if ($item['type'] == 'audio') {
-          $source_lists[0][] = $item;
+          $source_lists[0][$delta] = $item;
         }
       }
     }
@@ -364,22 +371,20 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
     if ($multiple_file_behavior == 'tags') {
       foreach ($items as $delta => $item) {
         if ($item['type'] == 'video') {
-          $source_lists[] = array($item);
+          $source_lists[$delta] = array($item);
         }
       }
     }
     else {
       foreach ($items as $delta => $item) {
         if ($item['type'] == 'video') {
-          $source_lists[0][] = $item;
+          $source_lists[0][$delta] = $item;
         }
       }
     }
 
     // Render each source list as an <video> element.
     foreach ($source_lists as $delta => $sources) {
-      $width = $settings['width'];
-      $height = $settings['height'];
       $element[$delta] = array(
         '#theme' => 'file_entity_file_video',
         '#files' => $sources,
@@ -387,8 +392,8 @@ function file_entity_field_formatter_view($entity_type, $entity, $field, $instan
         '#autoplay' => $settings['autoplay'],
         '#loop' => $settings['loop'],
         '#muted' => $settings['muted'],
-        '#width' => ($width && $height) ? $width : NULL,
-        '#height' => ($width && $height) ? $height : NULL,
+        '#width' => $settings['width'],
+        '#height' => $settings['height'],
       );
     }
   }
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.file.inc b/drupal7/sites/all/modules/file_entity/file_entity.file.inc
index d5cfadc8..74feaa6f 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.file.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.file.inc
@@ -59,17 +59,15 @@ function file_entity_file_insert($file) {
 
   // Save file metadata.
   if (!empty($file->metadata)) {
+    $query = db_insert('file_metadata')->fields(array('fid', 'name', 'value'));
     foreach ($file->metadata as $name => $value) {
-      db_merge('file_metadata')
-        ->fields(array(
-          'value' => serialize($value),
-        ))
-        ->key(array(
-          'fid' => $file->fid,
-          'name' => $name,
-        ))
-        ->execute();
+      $query->values(array(
+        'fid' => $file->fid,
+        'name' => $name,
+        'value' => serialize($value),
+      ));
     }
+    $query->execute();
   }
 
   // Clear any related field caches.
@@ -84,40 +82,26 @@ function file_entity_file_update($file) {
   field_attach_update('file', $file);
 
   // Save file metadata.
+  db_delete('file_metadata')->condition('fid', $file->fid)->execute();
   if (!empty($file->metadata)) {
+    $query = db_insert('file_metadata')->fields(array('fid', 'name', 'value'));
     foreach ($file->metadata as $name => $value) {
-      db_merge('file_metadata')
-        ->fields(array(
-          'value' => serialize($value),
-        ))
-        ->key(array(
-          'fid' => $file->fid,
-          'name' => $name,
-        ))
-        ->execute();
-    }
-  }
-
-  // Save file metadata.
-  db_delete('file_metadata')->condition('fid', $file->fid);
-  if (!empty($file->metadata)) {
-    foreach ($file->metadata as $name => $value) {
-      db_merge('file_metadata')
-        ->fields(array(
-          'value' => serialize($value),
-        ))
-        ->key(array(
-          'fid' => $file->fid,
-          'name' => $name,
-        ))
-        ->execute();
+      $query->values(array(
+        'fid' => $file->fid,
+        'name' => $name,
+        'value' => serialize($value),
+      ));
     }
+    $query->execute();
   }
 
-  if (file_entity_file_get_mimetype_type($file) == 'image' && module_exists('image')) {
-    // If the image dimensions have changed, update any image field references
-    // to this file and flush image style derivatives.
-    if ($file->metadata['width'] != $file->metadata['width'] || $file->metadata['height'] != $file->metadata['height']) {
+  if (module_exists('image') && file_entity_file_get_mimetype_type($file) == 'image' && $file->filesize) {
+    // If the file has changed dimensions or a new file has been uploaded,
+    // update any image field reference to this file and flush image style
+    // derivatives.
+    $file->metadata += array('width' => NULL, 'height' => NULL);
+    $file->original->metadata += array('width' => NULL, 'height' => NULL);
+    if ($file->filesize != $file->original->filesize || $file->metadata['width'] != $file->original->metadata['width'] || $file->metadata['height'] != $file->original->metadata['height']) {
       _file_entity_update_image_field_dimensions($file);
     }
 
@@ -246,6 +230,12 @@ function file_entity_metadata_fetch_image_dimensions($file) {
  * @see http://drupal.org/node/1448124
  */
 function _file_entity_update_image_field_dimensions($file) {
+  // Prevent PHP notices when trying to read empty files.
+  // @see http://drupal.org/node/681042
+  if (!$file->filesize) {
+    return;
+  }
+
   // Do not bother proceeding if this file does not have an image mime type.
   if (file_entity_file_get_mimetype_type($file) != 'image') {
     return;
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.file_api.inc b/drupal7/sites/all/modules/file_entity/file_entity.file_api.inc
index 9baa1a45..cfb75f9b 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.file_api.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.file_api.inc
@@ -484,6 +484,31 @@ function file_type_is_disabled($type) {
   return !empty($type->disabled);
 }
 
+/**
+ * Returns an array of valid file extensions.
+ */
+function file_type_get_valid_extensions($type) {
+  include_once DRUPAL_ROOT . '/includes/file.mimetypes.inc';
+  $mapping = file_mimetype_mapping();
+
+  $type_extensions = array();
+  $type_ext_keys = array();
+  if (!empty($type->mimetypes)) {
+    foreach ($mapping['mimetypes'] as $ext_key => $mimetype) {
+      if (file_entity_match_mimetypes($mimetype, $type->mimetypes)) {
+        $type_ext_keys[] = $ext_key;
+      }
+    }
+
+    if ($type_ext_keys) {
+      $type_extensions = array_intersect($mapping['extensions'], $type_ext_keys);
+      $type_extensions = array_keys($type_extensions);
+    }
+  }
+
+  return $type_extensions;
+}
+
 /**
  * Updates an existing file type or creates a new one.
  *
@@ -596,6 +621,7 @@ function file_type_delete($type) {
  *   Type of the file_type to disable
  */
 function file_type_enable($type) {
+  ctools_include('export');
   ctools_export_crud_enable('file_type', $type);
 }
 
@@ -607,6 +633,7 @@ function file_type_enable($type) {
  *   Type of the file_type to disable
  */
 function file_type_disable($type) {
+  ctools_include('export');
   ctools_export_crud_disable('file_type', $type);
 }
 
@@ -699,7 +726,7 @@ function file_uri_to_object($uri, $use_existing = TRUE) {
   if (empty($file)) {
     $file = new stdClass();
     $file->uid = $GLOBALS['user']->uid;
-    $file->filename = basename($uri);
+    $file->filename = drupal_basename($uri);
     $file->uri = $uri;
     $file->filemime = file_get_mimetype($uri);
     // This is gagged because some uris will not support it.
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc b/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
index c96f6a1a..74ca6609 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
+++ b/drupal7/sites/all/modules/file_entity/file_entity.file_default_displays.inc
@@ -93,6 +93,45 @@ function file_entity_file_default_displays() {
   $file_display->settings = '';
   $file_displays['image__teaser__file_field_file_default'] = $file_display;
 
+  // Enhance the default image displays if the Image module is enabled.
+  if (module_exists('image')) {
+    // Images should be displayed as unstyled images by default.
+    $file_display = new stdClass();
+    $file_display->api_version = 1;
+    $file_display->name = 'image__default__file_field_image';
+    $file_display->weight = 49;
+    $file_display->status = TRUE;
+    $file_display->settings = array(
+      'image_style' => '',
+      'image_link' => '',
+    );
+    $file_displays['image__default__file_field_image'] = $file_display;
+
+    // Image previews should be displayed as image thumbnails by default.
+    $file_display = new stdClass();
+    $file_display->api_version = 1;
+    $file_display->name = 'image__preview__file_field_image';
+    $file_display->weight = 49;
+    $file_display->status = TRUE;
+    $file_display->settings = array(
+      'image_style' => 'thumbnail',
+      'image_link' => '',
+    );
+    $file_displays['image__preview__file_field_image'] = $file_display;
+
+    // Image teasers should be displayed as medium images by default.
+    $file_display = new stdClass();
+    $file_display->api_version = 1;
+    $file_display->name = 'image__teaser__file_field_image';
+    $file_display->weight = 49;
+    $file_display->status = TRUE;
+    $file_display->settings = array(
+      'image_style' => 'medium',
+      'image_link' => 'content',
+    );
+    $file_displays['image__teaser__file_field_image'] = $file_display;
+  }
+
   $file_display = new stdClass();
   $file_display->api_version = 1;
   $file_display->name = 'video__default__file_field_file_video';
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.info b/drupal7/sites/all/modules/file_entity/file_entity.info
index 623ae375..a34997e6 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.info
+++ b/drupal7/sites/all/modules/file_entity/file_entity.info
@@ -10,6 +10,7 @@ files[] = views/views_handler_argument_file_type.inc
 files[] = views/views_handler_field_file_rendered.inc
 files[] = views/views_handler_field_file_type.inc
 files[] = views/views_handler_filter_file_type.inc
+files[] = views/views_handler_filter_schema_type.inc
 files[] = views/views_handler_field_file_filename.inc
 files[] = views/views_handler_field_file_link.inc
 files[] = views/views_handler_field_file_link_edit.inc
@@ -24,9 +25,9 @@ configure = admin/config/media/file-settings
 ; We have to add a fake version so Git checkouts do not fail Media dependencies
 version = 7.x-2.x-dev
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "file_entity"
-datestamp = "1382744726"
+datestamp = "1412420930"
 
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.install b/drupal7/sites/all/modules/file_entity/file_entity.install
index ca4ab066..bbf4b246 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.install
+++ b/drupal7/sites/all/modules/file_entity/file_entity.install
@@ -375,6 +375,8 @@ function file_entity_update_7104() {
             'permission' => 'view file',
             'module' => 'file_entity',
           ))
+          ->condition('rid', $rid)
+          ->condition('permission', 'view file')
           ->execute();
       }
     }
@@ -900,16 +902,13 @@ function file_entity_update_7210() {
 
   // Migrate any existing MIME type information into {file_type}.
   if (db_table_exists('file_type_mimetypes')) {
-    foreach (file_type_load_all(TRUE) as $type) {
-      $mimetypes = array();
-      $result = db_select('file_type_mimetypes', 'ftm')
+    module_load_include('inc', 'file_entity', 'file_entity.file_api');
+    $types = file_type_load_all(TRUE);
+    foreach ($types as $type) {
+      $mimetypes = db_select('file_type_mimetypes', 'ftm')
         ->fields('ftm', array('mimetype'))
-        ->condition('type', $type->type, '=')
-        ->execute();
-
-      foreach ($result as $record) {
-        $mimetypes[] = $record->mimetype;
-      }
+        ->condition('type', $type->type)
+        ->execute()->fetchCol();
 
       if (!empty($mimetypes)) {
         $type->mimetypes = $mimetypes;
diff --git a/drupal7/sites/all/modules/file_entity/file_entity.module b/drupal7/sites/all/modules/file_entity/file_entity.module
index 3ca0bb7d..5d058e4c 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.module
+++ b/drupal7/sites/all/modules/file_entity/file_entity.module
@@ -38,8 +38,7 @@ require_once dirname(__FILE__) . '/file_entity.field.inc';
  */
 function file_entity_hook_info() {
   $hooks = array(
-    'file_operation_info',
-    'file_operation_info_alter',
+    'file_operations',
     'file_type_info',
     'file_type_info_alter',
     'file_formatter_info',
@@ -84,6 +83,17 @@ function file_entity_hook_info_alter(&$info) {
   $info += array_fill_keys($hooks, array('group' => 'file'));
 }
 
+/**
+ * Implements hook_module_implements_alter().
+ */
+function file_entity_module_implements_alter(&$implementations, $hook) {
+  // nginx_accel_redirect_file_transfer() is an accidental hook implementation.
+  // @see https://www.drupal.org/node/2278625
+  if ($hook == 'file_transfer') {
+    unset($implementations['nginx_accel_redirect']);
+  }
+}
+
 /**
  * Implements hook_help().
  */
@@ -189,6 +199,20 @@ function file_entity_menu() {
     'type' => MENU_DEFAULT_LOCAL_TASK,
     'weight' => -10,
   );
+  $items['file/add/upload/file'] = array(
+    'title' => 'File',
+    'type' => MENU_DEFAULT_LOCAL_TASK,
+    'weight' => -10,
+  );
+  $items['file/add/upload/archive'] = array(
+    'title' => 'Archive',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('file_entity_upload_archive_form'),
+    'access arguments' => array('administer files'),
+    'file' => 'file_entity.pages.inc',
+    'type' => MENU_LOCAL_TASK,
+    'weight' => -5,
+  );
   $items['file/%file'] = array(
     'title callback' => 'entity_label',
     'title arguments' => array('file', 1),
@@ -1113,9 +1137,16 @@ function file_entity_file_formatter_file_field_view($file, $display, $langcode)
       // Set $display['type'] to what hook_field_formatter_*() expects.
       $display['type'] = $field_formatter_type;
 
+      // Allow any attribute overrides (e.g. from the Media module) to be
+      // respected.
+      $item = (array) $file;
+      if (!empty($file->override['attributes'])) {
+        $item = array_merge($item, $file->override['attributes']);
+      }
+
       // Set $items to what file field formatters expect. See file_field_load(),
       // and note that, here, $file is already a fully loaded entity.
-      $items = array((array) $file);
+      $items = array($item);
 
       // Invoke hook_field_formatter_prepare_view() and
       // hook_field_formatter_view(). Note that we are reusing field formatter
@@ -1878,6 +1909,13 @@ function _file_entity_query_file_entity_access_alter($query, $type) {
           $file_conditions->exists($subquery);
         }
         // Otherwise attach it to the node query itself.
+        elseif ($table == 'file_managed') {
+          // Fix for https://drupal.org/node/2073085
+          $db_or = db_or();
+          $db_or->exists($subquery);
+          $db_or->isNull($falias . '.' . $field);
+          $query->condition($db_or);
+        }
         else {
           $query->exists($subquery);
         }
@@ -1917,7 +1955,7 @@ function file_entity_file_download($uri) {
     return file_get_content_headers($file);
   }
 
-  return NULL;
+  return -1;
 }
 
 /**
@@ -2151,59 +2189,6 @@ function file_entity_upload_validators_pre_render($element) {
   return $element;
 }
 
-/**
- * Implements hook_file_default_displays_alter() on behalf of image.module.
- */
-function image_file_default_displays_alter(&$file_displays) {
-  // Images should be displayed as unstyled images by default.
-  if (isset($file_displays['image__default__file_field_file_default'])) {
-    $file_displays['image__default__file_field_file_default']->status = FALSE;
-  }
-
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'image__default__file_field_image';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = array(
-    'image_style' => '',
-    'image_link' => '',
-  );
-  $file_displays['image__default__file_field_image'] = $file_display;
-
-  // Image previews should be displayed as image thumbnails by default.
-  if (isset($file_displays['image__preview__file_field_file_default'])) {
-    $file_displays['image__preview__file_field_file_default']->status = FALSE;
-  }
-
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'image__preview__file_field_image';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = array(
-    'image_style' => 'thumbnail',
-    'image_link' => '',
-  );
-  $file_displays['image__preview__file_field_image'] = $file_display;
-
-  // Image teasers should be displayed as medium images by default.
-  if (isset($file_displays['image__teaser__file_field_file_default'])) {
-    $file_displays['image__teaser__file_field_file_default']->status = FALSE;
-  }
-
-  $file_display = new stdClass();
-  $file_display->api_version = 1;
-  $file_display->name = 'image__teaser__file_field_image';
-  $file_display->weight = 50;
-  $file_display->status = TRUE;
-  $file_display->settings = array(
-    'image_style' => 'medium',
-    'image_link' => 'content',
-  );
-  $file_displays['image__teaser__file_field_image'] = $file_display;
-}
-
 /**
  * @name pathauto_file Pathauto integration for the core file module.
  * @{
@@ -2265,7 +2250,7 @@ function pathauto_file_operations() {
  */
 function pathauto_file_update_alias(stdClass $file, $op, array $options = array()) {
   // Skip processing if the user has disabled pathauto for the file.
-  if (isset($file->path['pathauto']) && empty($file->path['pathauto'])) {
+  if (isset($file->path['pathauto']) && empty($file->path['pathauto']) && empty($options['force'])) {
     return;
   }
 
@@ -2482,21 +2467,25 @@ function file_entity_admin_menu_map() {
 }
 
 /*
- * Generate a file download CSRF token.
+ * Generates a token to protect a file download URL.
+ *
+ * This prevents unauthorized crawling of all file download URLs since the
+ * {file_managed}.fid column is an auto-incrementing serial field and is easy
+ * to guess or attempt many at once. This can be costly both in CPU time
+ * and bandwidth.
  *
- * This is essentially a duplicate of drupal_get_token, that attempts to still
- * work if the user is anonymous, by using ip_address() as the identifier
- * rather than session_id().
+ * @see image_style_path_token()
  *
  * @param object $file
  *   A file entity object.
  *
  * @return string
- *   A CSRF token string.
+ *   An eight-character token which can be used to protect file downloads
+ *   against denial-of-service attacks.
  */
 function file_entity_get_download_token($file) {
-  $identifier = !empty($GLOBALS['user']->uid) ? session_id() : ip_address();
-  return drupal_hmac_base64("file/$file->fid/download", $identifier . drupal_get_private_key() . drupal_get_hash_salt());
+  // Return the first eight characters.
+  return substr(drupal_hmac_base64("file/$file->fid/download:" . $file->uri, drupal_get_private_key() . drupal_get_hash_salt()), 0, 8);
 }
 
 /**
@@ -2542,7 +2531,7 @@ function file_entity_field_attach_load($entity_type, $entities, $age, $options)
           foreach ($items as $delta => $item) {
             // If alt and title text is not specified, fall back to alt and
             // title text on the file.
-            if (empty($item['alt']) || empty($item['title'])) {
+            if (!empty($item['fid']) && (empty($item['alt']) || empty($item['title']))) {
               $file = file_load($item['fid']);
               foreach (array('alt', 'title') as $key) {
                 if (empty($item[$key]) && !empty($file->{$key})) {
